# Clean brightest maser channel and use for self-cal
# The calibration improves the S/N in the water line
# but does not improve the other spw so it is only
# applied to this spw.
# This is after adjusting to constant velocity in lsrk

os.system('rm -rf X4ab_SgrB2_spw1_1496.clean*')
tclean(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183', 
       imagename='X4ab_SgrB2_spw1_1496.clean',
       field='0', 
       spw='1', 
       specmode='cube', 
       start=1496, 
       nchan=1,
       gridder='mosaic'
       pblimit=0.05,
       imsize=1200, 
       cell='0.04arcsec', 
       weighting='briggs',
       robust=0.5, 
       uvtaper='0.3arcsec', 
       niter=100, 
       cycleniter=50,
       savemodel='modelcolumn', 
       interactive=T)
# 8.646220e+01 / 2.128247e+00  S/N ~41

gaincal(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183',
        field='Sgr_B2N',
        caltable='X4ab_Sgr_B2N_1-1496.p1',
        refant='DV12',
        spw='1:1496',
        calmode='p',
        solint='31s')

applycal(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183',
         gaintable='X4ab_Sgr_B2N_1-1496.p1',
         spw='1',
         spwmap=[1],
         calwt=F,
         applymode='calonly')
#####

os.system('rm -rf X4ab_SgrB2_spw1_1496_p1.clean*')
tclean(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183',
	imagename='X4ab_SgrB2_spw1_1496_p1.clean',
	field='0',
	spw='1',
	specmode='cube',
	start=1496,
        nchan=1,
	gridder='mosaic',
        pblimit=0.05,
	imsize=1200,
        cell='0.04arcsec',
        weighting='briggs',
        robust=0.5,
	uvtaper='0.3arcsec',
	niter=500,
        cycleniter=50,
        savemodel='modelcolumn',
	interactive=T)
# 1.832676e+11 GHz 
# S/N 1.030289e+02/7.014098e-01

gaincal(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183',
        field='Sgr_B2N',
        caltable='X4ab_Sgr_B2N_1-1496.p2',
        refant='DV12',
        spw='1:1496',
        calmode='p',
        solint='int')

applycal(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183',
         gaintable='X4ab_Sgr_B2N_1-1496.p2',
         spw='1',
         spwmap=[1],
         applymode='calonly')
#####
os.system('rm -rf X4ab_SgrB2_spw1_1496_p2.clean*')
tclean(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183',
	imagename='X4ab_SgrB2_spw1_1496_p2.clean',
	field='0',
	spw='1',
	specmode='cube',
	start=1496,
        nchan=1,
	gridder='mosaic',
        pblimit=0.05,
	imsize=1200,
        cell='0.04arcsec',
        weighting='briggs',
        robust=0.5,
	uvtaper='0.3arcsec',
	niter=500,
        cycleniter=50,
        savemodel='modelcolumn',
	interactive=T)
#1.077209e+02/6.218123e-01 S/N 173
#######


gaincal(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183',
        field='Sgr_B2N',
        caltable='X4ab_Sgr_B2N_1-1496.a',
        refant='DV12',
        spw='1:1496',
        gaintype='T',
        calmode='a',
        gaintable='X4ab_Sgr_B2N_1-1496.p2',
        solint='35s')

#es.checkCalTable('X4ab_Sgr_B2N_1-1496.a', msName='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183', interactive=False) 

applycal(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183',
         gaintable=['X4ab_Sgr_B2N_1-1496.p2','X4ab_Sgr_B2N_1-1496.a'],
         spw='1',
         spwmap=[[1],[1]])
#####
os.system('rm -rf X4ab_SgrB2_spw1_1496_ap.clean*')
tclean(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183',
	imagename='X4ab_SgrB2_spw1_1496_ap.clean',
	field='0',
	spw='1',
	specmode='cube',
	start=1496,
        nchan=1,
	gridder='mosaic',
        pblimit=0.05,
	imsize=1200,
        cell='0.04arcsec',
        weighting='briggs',
        robust=0.5,
	uvtaper='0.3arcsec',
	niter=500,
        cycleniter=50,
        savemodel='modelcolumn',
	interactive=T)
# 1.061746e+02/4.218440e-01  250

# Then make final cube!
# don't forget to set rest freq and lsrk to make sure labelling is correct

os.system('rm -rf X4ab_SgrB2_spw1_H2O.clean*')
tclean(vis='X4ab_Sgr_B2N.ms.LSRK_FluxEqual_concat_183', 
       imagename='X4ab_SgrB2_spw1_H2O.clean',
       field='0', 
       spw='1', 
       specmode='cube', 
       start=1400, 
       nchan=200,
       outframe='lsrk',
       restfreq='183.310GHz',
       gridder='mosaic', 
       pblimit=0.05,
       imsize=800, 
       cell='0.04arcsec', 
       weighting='briggs',
       robust=0.5, 
       uvtaper='0.3arcsec', 
       niter=2000000, 
       cycleniter=100,
       interactive=T)

# Make primary-beam corrected FITS images:
# X4ab_SgrB2_spw1_1496 is pre-self-cal for the best position
# X4ab_SgrB2_spw1_H2O is a cube centred on the self-calibrated 
# water line.  Beware aretefacts in extended emission.

imlist=['X4ab_SgrB2_spw1_1496.clean','X4ab_SgrB2_spw1_H2O.clean']
for i in imlist:
    impbcor(imagename=i+'.image',
            pbimage=i+'.pb',
            outfile=i+'.pbcorr')
    exportfits(imagename=i+'.pbcorr',
               fitsimage=i+'.pbcorr.fits')
    exportfits(imagename=i+'.pb',
               fitsimage=i+'.pb.fits')
